//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "example_dll.h"

//#define MAKE_LOG
//Vypnuty vypisy

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TExample *Example;

//---------------------------------------------------------------------------
__fastcall TExample::TExample(TComponent* Owner)
  : TForm(Owner)
{
}

DWORD Ihandle;
int state;

//---------------------------------------------------------------------------
void __fastcall TExample::FormCreate(TObject *Sender)
{
  int result_;
  is_running=false;
  state=0;

  #ifdef MAKE_LOG           //Zapnuto logovani?
    Td_Start_Logging();           //Zapnuti logovaciho systemu do pametoveho proudu
    Td_Assign_File("make_log.txt");         //Prirazeni pametoveho proudu  k souboru (vse doposud ulozene do pameti se ulozi do souboru a dale se vse bude ukladat bezprostredne do souboru)
    Td_Insert_Log("Begin watch file:");     //Vlozim 1. vypis
  #endif


  //pokusim se inicializovat kartu zadaneho jmena
  result_=Td_Init_Driver(&Ihandle,"EXAM");
  if(result_!=0)
  {
    MessageBox(NULL,"Nenalezeno dn aktivn zazen s nzvem EXAM, pouijte administran program [admin.exe].","Chyba!!",MB_OK);
    resolve_error(result_);
    Application->Terminate();
  }
}

//---------------------------------------------------------------------------
void __fastcall TExample::FormClose(TObject *Sender, TCloseAction &Action)
{
  DWORD result_;
  result_=Td_Close_Driver(Ihandle);
  if(result_!=0)
  {
    //Nezdaen skonen komunikace, operaci nelze provst.
    resolve_error(result_);
    return;
  }

  #ifdef MAKE_LOG
    Td_Stop_Logging();  //Zastavim logovani
  #endif
}

//---------------------------------------------------------------------------


void __fastcall TExample::ClearClick(TObject *Sender)
{
  Cchannels=0;
  ItemsOfChannels->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TExample::AddClick(TObject *Sender)
{
  int mux,gain;
  try
  {
    mux=param0->Text.ToInt();
    if(mux<0) throw Exception("");

    gain=param1->Text.ToInt();
    if(gain<0) throw Exception("");
  }
  catch(...)
  {
    ShowMessage("sla zadn v kolonkch 0. parametr a 1. parametr mus bt cel kladn!");
    exit;
  }

  channels[Cchannels].mux=mux;
  channels[Cchannels].gain=gain;

  ItemsOfChannels->Items->Add(AnsiString(mux)+"   /   "+AnsiString(gain));
  Cchannels++;
}
//---------------------------------------------------------------------------


void __fastcall TExample::BufferAcquisitionClick(TObject *Sender)
{
  DWORD SetCNTReg_cnt0;
  DWORD SetCNTReg_cnt1;
  DWORD* buffer;
  DWORD result_;
  double frequency;
  double period;
  DWORD count_new_row;
  TGridRect myRect;

  DWORD* buffer_loc;   //uzivatelsky buffer pro alokovane data
  DWORD size_of_buffer; //delka uziv bufferu

  DWORD CfgCNT0;
  DWORD CfgCNT1;
  
  int active_column;
  int i,j;
  int info_cnt;
  int complete_sequence;

  //zastavim mereni, kdyz se meri
  if(is_running)
  {
    result_=M_stop_measuring();
    if(result_!=0)
      return;
  }

  state=2; //nastavim stav podle typu mereni, ktere probiha

  //Nacteme hodnoty ovladacich prvku
  if (Cchannels<=0)
  {
    Application->MessageBox("Poet kanl mus bt cel kladn slo.","Chyba!",MB_ICONERROR);
    return;
  }

  try
  {
    frequency=Vfrequency->Text.ToInt();
  }
  catch(...)
  {
    Application->MessageBox("Frekvence mus bt slo.","Chyba!",MB_ICONERROR);
    return;
  }

  if(frequency<=0)
  {
    Application->MessageBox("Frekvence mus bt kladn slo uren podle vyuvanho zazen.","Chyba!",MB_ICONERROR);
    return;
  }

  Td_Config_ScanCounter(Ihandle,1,0);
  Td_Config_ScanCounter(Ihandle,1,1);

  //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
  for(i=0;i!=Cchannels;i++)
  {
    result_=Td_Config_Acquisition(Ihandle,channels[i].mux,channels[i].gain,i,Cchannels);
    if (result_!=0)
    {
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      return;
    }
  }


  //nastavime frekvenci
  period=0;
  result_=Td_Config_Timing_Acquisition(Ihandle,&frequency,&period);
  if(result_!=0)
  {
    //Nepodailo se nastavit frekvenci tae.
    resolve_error(result_);
    return;
  }

  //Odstarujeme mereni s SW rizenim
  result_=Td_Start_Acquisition(Ihandle,2);
  if(result_!=0)
  {
    //Nepodailo se odstartovat men.
    resolve_error(result_);
    return;
  }

  size_of_buffer=10000;
  buffer_loc=(DWORD*)malloc(sizeof(DWord)*size_of_buffer);
  active_column=0;
  count_new_row=0;
  is_running=true;
  info_cnt=0;

  BufferAcquisition->Enabled=false;
  OneAcquisition->Enabled=false;
  StopAcquisition->Enabled=true;

  while (is_running) //Tato smycka se prerusi ukonceni formulare (OnClose nastavi is_running na false)
  {
    //Posleme si pro data
    result_=Td_Get_Buffer_Data(Ihandle,buffer_loc,size_of_buffer,&count_new_row);
    if(result_!=0)
    {
      //Nepodailo se namit hodnoty.
      resolve_error(result_);
      return;
    }

    //prisly nejake data?
    complete_sequence=count_new_row/Cchannels;
    if(complete_sequence>0)
    {
      for(i=0;i!=complete_sequence;i++)
      {
        StringGrid1->RowCount=max(min(size_of_buffer,Cchannels)+1,2);
        for(j=1;j!=min(size_of_buffer,Cchannels)+1;j++)
        {
          StringGrid1->Cells[active_column][j]=AnsiString(buffer_loc[j-1]);
        }

        myRect.Left= active_column;
        myRect.Top= 1;
        myRect.Right= active_column;
        myRect.Bottom= size_of_buffer+1;
        StringGrid1->Selection= myRect;
        StringGrid1->Refresh();
        active_column=(active_column+1)%StringGrid1->ColCount;
      }
    }

    info_cnt++;
    if((info_cnt%10)==0)
    {
      Application->ProcessMessages();  //Obcas je treba volat obsluhu zprav aby aplikace "zila"
    }
    Sleep(5);
  }

  free(buffer_loc);
}

//---------------------------------------------------------------------------
//Pomocne procedury pro zastaveni mereni a uzavreni karty
DWORD __fastcall TExample::M_stop_measuring()
{
  DWORD result_;
  result_=Td_Stop_Acquisition(Ihandle);
  if(result_!=0)
  {
    //Nezdailo se zastavit men.
    resolve_error(result_);
    return 1;
  }

  is_running=false;
  return 0;
}

void __fastcall TExample::StopAcquisitionClick(TObject *Sender)
{
  DWORD result_;

  if(is_running)
  {
    result_=M_stop_measuring();
    if(result_!=0)
    {
      return;
    }

    BufferAcquisition->Enabled=true;
    StopAcquisition->Enabled=false;
  }
  SingleBox->Enabled=true;  
}

//Procedura, ktera vytvori message box s chybovou zprvou
void TExample::resolve_error(DWORD n_error)
{
  char function_[1000];
  char error_[1000];

  Td_Get_ErrorMessage(n_error,&function_[0],&error_[0]);
  MessageBox(NULL,&error_[0],&function_[0],MB_ICONERROR);
}


void __fastcall TExample::ConfigSingleAcquisitionClick(TObject *Sender)
{
  DWORD SetCNTReg_cnt0;
  DWORD SetCNTReg_cnt1;
  DWORD result_;
  double frequency;
  double period;
  DWORD count_new_row;
  TGridRect myRect;

  DWORD* buffer_loc;   //uzivatelsky buffer pro alokovane data
  DWORD size_of_buffer; //delka uziv bufferu

  DWORD CfgCNT0;
  DWORD CfgCNT1;
  
  int i,j;
  int info_cnt;
  int complete_sequence;

  active_column=0;
  
  //zastavim mereni, kdyz se meri
  if(is_running)
  {
    result_=M_stop_measuring();
    if(result_!=0)
      return;
  }

  state=2; //nastavim stav podle typu mereni, ktere probiha

  //Nacteme hodnoty ovladacich prvku
  if (Cchannels<=0)
  {
    Application->MessageBox("Poet kanl mus bt cel kladn slo.","Chyba!",MB_ICONERROR);
    return;
  }

  try
  {
    frequency=Vfrequency->Text.ToInt();
  }
  catch(...)
  {
    Application->MessageBox("Frekvence mus bt slo.","Chyba!",MB_ICONERROR);
    return;
  }

  if(frequency<=0)
  {
    Application->MessageBox("Frekvence mus bt kladn slo uren podle vyuvanho zazen.","Chyba!",MB_ICONERROR);
    return;
  }

  //Nastavime analogove vstupni kanaly, zesileni zvolime pro vsechny 1x
  for(i=0;i!=Cchannels;i++)
  {
    result_=Td_Config_Acquisition(Ihandle,channels[i].mux,channels[i].gain,i,Cchannels);
    if (result_!=0)
    {
      //Nepodailo se nastavit kanly.
      resolve_error(result_);
      return;
    }
  }


  //Odstarujeme mereni s SW rizenim
  result_=Td_Start_Acquisition(Ihandle,1);
  if(result_!=0)
  {
    //Nepodailo se odstartovat men.
    resolve_error(result_);
    return;
  }


  ConfigSingleAcquisition->Enabled=false;
  OneAcquisition->Enabled=true;
  StopSingleAcquisition->Enabled=true;

  BufferBox->Enabled=false;

  is_running=true;
}
//---------------------------------------------------------------------------

void __fastcall TExample::StopSingleAcquisitionClick(TObject *Sender)
{
  DWORD result_;

  if(is_running)
  {
    result_=M_stop_measuring();
    if(result_!=0)
    {
      return;
    }

    ConfigSingleAcquisition->Enabled=true;
    OneAcquisition->Enabled=false;
    StopSingleAcquisition->Enabled=false;
  }
  BufferBox->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TExample::OneAcquisitionClick(TObject *Sender)
{
  DWORD result_;
  DWORD buffer_loc[1000];
  int j;
  TGridRect myRect;
    
  //Posleme si pro data
  result_=Td_Get_SingleAcquisition(Ihandle,&buffer_loc[0],min(Cchannels,1000));
  if(result_!=0)
  {
    //Nepodailo se namit hodnoty.
    resolve_error(result_);
    return;
  }

  StringGrid1->RowCount=max(min(1000,Cchannels)+1,2);
  for(j=1;j!=min(1000,Cchannels)+1;j++)
  {
    StringGrid1->Cells[active_column][j]=AnsiString(buffer_loc[j-1]);
  }

  //Oznacime oblast s novymi daty
  myRect.Left= active_column;
  myRect.Top= 1;
  myRect.Right= active_column;
  myRect.Bottom= min(Cchannels,1000)+1;
  StringGrid1->Selection= myRect;
  StringGrid1->Refresh();
  active_column=(active_column+1)%StringGrid1->ColCount;
}
//---------------------------------------------------------------------------

