/*------------------------------------------------------------------------------
  tedia_daq01_c.h

        Hlavikov soubor obsahujc konstanty pro TEDIA_DAQ01.DLL (verze 2.33).
------------------------------------------------------------------------------*/

#if !defined(__TEDIA_DAQ01C)
#define __TEDIA_DAQ01C

/*------------------------------------------------------------------------------
* Konstanty pro funkci Td_Set_Parameters a Td_Get_Parameters
--------------------------------------------------------------------------------*/
  #define SETGET_CONFIG_SAVE_delays             0     /*0-neukldat, 1-ukldat zpodn do zazen automaticky pri prvnm Td_Config_Acquisition */

  //pro nejni frekvence je zvolen mod "buffer 256B a peruen po 1 sekvenci
  #define SETGET_decide_frequency_0             8     /*rozhodovac hodnota frekvence pro "mod buffer 256B a peruen po 128B"                  */
  #define SETGET_decide_frequency_1             9     /*rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 256B"                  */
  #define SETGET_decide_frequency_2             10    /*rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 512B"                  */
  #define SETGET_decide_frequency_3             11    /*rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 2kB"                   */
  #define SETGET_decide_frequency_4             12    /*rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 8kB"                   */
  #define SETGET_decide_frequency_5             13    /*rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 32kB"                  */
  #define SETGET_support_digital_input          14    /*podpora funkce Td_Get_DI blokovm penosu dat z USB zazen                             */

  #define SETGET_digital_0                      15    /*smr digitlnho portu 0 (0-vstup, 1-vstup)                                             */
  #define SETGET_digital_1                      16    /*smr digitlnho portu 1                                                                 */
  #define SETGET_digital_2                      17    /*smr digitlnho portu 2                                                                 */
  #define SETGET_digital_3                      18    /*smr digitlnho portu 3                                                                 */
  #define SETGET_INIT_SAVE_digitals             50    /*0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) smry digitlnch port*/

  #define SETGET_delay_0                        70     /*zpodn pidn pi innosti extern. multiplexeru                                       */
  #define SETGET_delay_1                        71     /*zpodn po odmen kanlu s 1. zeslenm                                               */
  #define SETGET_delay_2                        72     /*zpodn po odmen kanlu s 2. zeslenm                                               */
  #define SETGET_delay_3                        73     /*zpodn po odmen kanlu s 3. zeslenm                                               */
  #define SETGET_delay_4                        74     /*zpodn po odmen kanlu s 4. zeslenm                                               */
  #define SETGET_delay_5                        75     /*zpodn po odmen kanlu s 5. zeslenm                                               */
  #define SETGET_delay_6                        76     /*zpodn po odmen kanlu s 6. zeslenm                                               */
  #define SETGET_delay_7                        77     /*zpodn po odmen kanlu s 7. zeslenm                                               */

  #define SETGET_INIT_SAVE_AO_references        100   /* 0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) referenn zdroje napt*/
  #define SETGET_AO_reference_0                 101   /* hodnota referennho napt pro zdroj -10V                                                      */
  #define SETGET_AO_reference_1                 102   /* hodnota referennho napt pro zdroj -5V                                                       */
  #define SETGET_AO_reference_2                 103   /* hodnota referennho napt pro zdroj +5V                                                       */
  #define SETGET_AO_reference_3                 104   /* hodnota referennho napt pro zdroj +10V                                                      */

  #define SETGET_INIT_SAVE_AI_calibration       110   /* 0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) kalibrace podle nsledujcch konstant  */
  #define SETGET_AI_offset_ADC0                 111   /* 8bit. hodnota kalibrujc ADC (pro gain 1x)*/
  #define SETGET_AI_range_ADC0                  112   /* 8bit. hodnota kalibrujc rozsah ADC*/
  #define SETGET_AI_offset_roughly              113   /* 8bit. hodnota kalibrujc offset vstup. zesilovace (hrube)*/
  #define SETGET_AI_offset_softly               114   /* 8bit. hodnota kalibrujc offset vstup. zesilovace (jemne)*/
  #define SET_AI_connect_ground                 115   /* pipojit vstup A/D pevodnku na GND msto multiplexoru (1-GND, 0-multiplexor)*/

  #define SETGET_INIT_SAVE_average              130   /* 0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) prmrovn vzork*/
  #define SETGET_average                        131   /* 0-neprmrovat, 1-prmrovat*/

  #define SETGET_INIT_SAVE_AO                   150   /* 0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) hodnoty, rozsahy a povolen analogovch vstup*/
  #define SETGET_AO_allow                       151   /* 0-neaktivn, 1-analogov vstupy aktivovny                                                                              */
  #define SETGET_AO_0_value                     152   /* hodnota 0. analogovho vstupu                                                                                         */
  #define SETGET_AO_1_value                     153   /* hodnota 1. analogovho vstupu                                                                                         */
  #define SETGET_AO_2_value                     154   /* hodnota 2. analogovho vstupu                                                                                         */
  #define SETGET_AO_3_value                     155   /* hodnota 3. analogovho vstupu                                                                                         */
  #define SETGET_AO_4_value                     156   /* hodnota 4. analogovho vstupu                                                                                         */
  #define SETGET_AO_5_value                     157   /* hodnota 5. analogovho vstupu                                                                                         */
  #define SETGET_AO_6_value                     158   /* hodnota 6. analogovho vstupu                                                                                         */
  #define SETGET_AO_7_value                     159   /* hodnota 7. analogovho vstupu                                                                                         */
  #define SETGET_AO_0_range                     200   /* rozsah 0. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_1_range                     201   /* rozsah 1. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_2_range                     202   /* rozsah 2. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_3_range                     203   /* rozsah 3. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_4_range                     204   /* rozsah 4. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_5_range                     205   /* rozsah 5. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_6_range                     206   /* rozsah 6. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */
  #define SETGET_AO_7_range                     207   /* rozsah 7. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)                                    */

  #define SETGET_INIT_SAVE_AI_24or16bit         250   /*-0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) hodnotu poet bit pevodnku */
  #define SETGET_AI_24bit                       251   /*0-16. bitov pevod, 1-24. bitov pevod                                                               */

  #define SETGET_Number_Of_Strings_Info         260  /*0-poet doplujcch informac uloench po dcch v SETGET_String1 - SETGET_String16 */ 
  #define SETGET_String1                        261  /*string 1 */
  #define SETGET_String16                       276  /*string 16 */


  /* Nezavysle na zarizeni (plati spolecne pro celou knihovnu, vsechna zarizeni)
   Pokud jsou nastavovany tyto parametry lze predat do handle nil hodnotu*/
  #define SETGET_Language                       350

  #define GET_Number_Of_Languages               400
  #define GET_LanguagesNameFirst                401
  #define GET_LanguagesNameMax                  410

/*------------------------------------------------------------------------------
* Konstanty pro funkci Td_Get_Generating_Status
------------------------------------------------------------------------------*/
  #define GET_BUFFER_SW_FILLED                          0    /* Poet naplnnch vzork v bufferu TEDIA_DAQ */
  #define GET_BUFFER_SW_FREE                            1    /* Poet volnch mist pro vzorky v bufferu TEDIA_DAQ */
  #define GET_BUFFER_HW_FILLED                          2    /* Poet naplnnch vzork v bufferu zazen  */

/*------------------------------------------------------------------------------
* Konstanty pro funkci Td_Set_Parameters
--------------------------------------------------------------------------------*/
  #define SET_save_load_EEPROM                  500   /*0-ukld, 1-nahrv hodnoty referennho napt do/z EEPROM  (konstanta je vyuiteln pouze ve funkci Td_Set_Parameters)*/

/*------------------------------------------------------------------------------
* Neviditelne uzivateli
--------------------------------------------------------------------------------*/
  #define SETGET_loaded_file                    1000  /*nzev souboru s FIRMWARE         */
  #define SETGET_load_file                      1001  /*0-nenahrvat, 1-nahrvat FIRMWARE*/


/*------------------------------------------------------------------------------
Konstanty pro funkci Td_Get_Info_DeviceType
------------------------------------------------------------------------------*/
/* IRQTimer*/
  #define INFO_TYPE_IRQTimer_max_frequency            1001 /* max. frekvence IRQTimeru*/
  #define INFO_TYPE_IRQTimer_min_frequency            1002 /* min. frekvence IRQTimeru*/

/* CNT*/
  #define INFO_TYPE_CNT_number_of_counters            1201 /* poet ta CNT*/
  #define INFO_TYPE_CNT_data_resolution               1202 /* poet datovch bit*/
  #define INFO_TYPE_CNT_function_resolution           1203 /* poet platnch bit*/
  #define INFO_TYPE_CNT_type                          1204 /* typ ta CNT*/

/* DI*/
  #define INFO_TYPE_DI_number_of_ports                1301 /* poet DI port*/
  #define INFO_TYPE_DI_data_resolution                1302 /* poet datovch bit*/
  #define INFO_TYPE_DI_function_resolution            1303 /* poet platnch bit*/
  #define INFO_TYPE_DI_type                           1304 /* typ DI port*/

/* AO*/
  #define INFO_TYPE_AO_number_of_outputs              1501 /* poet AO vstup*/
  #define INFO_TYPE_AO_data_resolution                1502 /* poet datovch bit*/
  #define INFO_TYPE_AO_function_resolution            1503 /* poet platnch bit*/
  #define INFO_TYPE_AO_type                           1504 /* typ AO vstup*/
  #define INFO_TYPE_AO_number_of_ranges               1510 /* poet rozsah AO*/
  #define INFO_TYPE_AO_minimum_of_range_0             1511 /* doln hranice rozsahu 0*/
  #define INFO_TYPE_AO_maximum_of_range_0             1512 /* horn hranice rozsahu 0*/
  #define INFO_TYPE_AO_minimum_of_range_1             1513 /* doln hranice rozsahu 1*/
  #define INFO_TYPE_AO_maximum_of_range_1             1514 /* horn hranice rozsahu 1*/
  #define INFO_TYPE_AO_minimum_of_range_2             1515 /* doln hranice rozsahu 2*/
  #define INFO_TYPE_AO_maximum_of_range_2             1516 /* horn hranice rozsahu 2*/
  #define INFO_TYPE_AO_minimum_of_range_3             1517 /* doln hranice rozsahu 3*/
  #define INFO_TYPE_AO_maximum_of_range_3             1518 /* horn hranice rozsahu 3*/

/* DO*/
  #define INFO_TYPE_DO_number_of_ports                1701 /* poet DO port*/
  #define INFO_TYPE_DO_data_resolution                1702 /* poet datovch bit*/
  #define INFO_TYPE_DO_function_resolution            1703 /* poet platnch bit*/
  #define INFO_TYPE_DO_type                           1704 /* typ DO port*/

/* ScanBuffer*/
  #define INFO_TYPE_ScanBuffer_max_frequency          2001 /* max. frekvence pro ScanBuffer*/
  #define INFO_TYPE_ScanBuffer_min_frequency          2002 /* min. frekvence pro ScanBuffer*/
  #define INFO_TYPE_ScanBuffer_max_number_of_channel  2010 /* max. poet kanl sekvence*/

/* ScanAI*/
  #define INFO_TYPE_ScanAI_number_of_inputs           2101 /* poet ScanAI vstup*/
  #define INFO_TYPE_ScanAI_data_resolution            2102 /* poet datovch bit*/
  #define INFO_TYPE_ScanAI_function_resolution        2103 /* poet platnch bit*/
  #define INFO_TYPE_ScanAI_type                       2104 /* typ ScanAI vstup*/
  #define INFO_TYPE_ScanAI_number_of_ranges           2110 /* poet rozsah ScanAI*/
  #define INFO_TYPE_ScanAI_minimum_of_range_0         2111 /* doln hranice rozsahu 0*/
  #define INFO_TYPE_ScanAI_maximum_of_range_0         2112 /* horn hranice rozsahu 0*/
  #define INFO_TYPE_ScanAI_minimum_of_range_1         2113 /* doln hranice rozsahu 1*/
  #define INFO_TYPE_ScanAI_maximum_of_range_1         2114 /* horn hranice rozsahu 1*/
  #define INFO_TYPE_ScanAI_minimum_of_range_2         2115 /* doln hranice rozsahu 2*/
  #define INFO_TYPE_ScanAI_maximum_of_range_2         2116 /* horn hranice rozsahu 2*/
  #define INFO_TYPE_ScanAI_minimum_of_range_3         2117 /* doln hranice rozsahu 3*/
  #define INFO_TYPE_ScanAI_maximum_of_range_3         2118 /* horn hranice rozsahu 3*/
  #define INFO_TYPE_ScanAI_minimum_of_range_4         2119 /* doln hranice rozsahu 4*/
  #define INFO_TYPE_ScanAI_maximum_of_range_4         2120 /* horn hranice rozsahu 4*/
  #define INFO_TYPE_ScanAI_minimum_of_range_5         2121 /* doln hranice rozsahu 5*/
  #define INFO_TYPE_ScanAI_maximum_of_range_5         2122 /* horn hranice rozsahu 5*/
  #define INFO_TYPE_ScanAI_minimum_of_range_6         2123 /* doln hranice rozsahu 6*/
  #define INFO_TYPE_ScanAI_maximum_of_range_6         2124 /* horn hranice rozsahu 6*/


/* ScanCNT*/
  #define INFO_TYPE_ScanCNT_number_of_counters        2201 /* poet ta ScanCNT*/
  #define INFO_TYPE_ScanCNT_data_resolution           2202 /* poet datovch bit*/
  #define INFO_TYPE_ScanCNT_function_resolution       2203 /* poet platnch bit*/
  #define INFO_TYPE_ScanCNT_type                      2204 /* typ ta ScanCNT*/

/* ScanDI*/
  #define INFO_TYPE_ScanDI_number_of_ports            2301 /* poet ScanDI port*/
  #define INFO_TYPE_ScanDI_data_resolution            2302 /* poet datovch bit*/
  #define INFO_TYPE_ScanDI_function_resolution        2303 /* poet platnch bit*/
  #define INFO_TYPE_ScanDI_type                       2304 /* typ ScanDI port*/

/* GenerBuffer */
  #define INFO_TYPE_GenerBuffer_max_frequency          2501 /* max. frekvence v reimu stream  */
  #define INFO_TYPE_GenerBuffer_min_frequency          2502 /* min. frekvence v reimu stream  */
  #define INFO_TYPE_GenerBuffer_max_DAC_frequency      2503 /* max. frekvence v cyklickm reimu */
  #define INFO_TYPE_GenerBuffer_min_DAC_frequency      2504 /* min. frekvence v cyklickm reimu */
  #define INFO_TYPE_GenerBuffer_DAC_depth              2505 /* velikost bufferu pro generovani */
  #define INFO_TYPE_GenerBuffer_cycling_mode           2506 /* umouje zazen cyklick generovani bufferu?  */
  #define INFO_TYPE_GenerBuffer_max_number_of_channel  2510 /* max. poet kanl sekvence */

/* GenerAO */
  #define INFO_TYPE_GenerAO_number_of_outputs          2601 /* poet GenerAO vstup           */
  #define INFO_TYPE_GenerAO_data_resolution            2602 /* poet datovch bit             */
  #define INFO_TYPE_GenerAO_function_resolution        2603 /* poet platnch bit             */
  #define INFO_TYPE_GenerAO_type                       2604 /* typ GenerAO vstup             */
  #define INFO_TYPE_GenerAO_number_of_ranges           2605 /* poet rozsah GenerAO           */
  #define INFO_TYPE_GenerAO_minimum_of_range_0         2606 /* doln hranice rozsahu 0         */
  #define INFO_TYPE_GenerAO_maximum_of_range_0         2607 /* horn hranice rozsahu 0         */
  #define INFO_TYPE_GenerAO_minimum_of_range_1         2608 /* doln hranice rozsahu 1         */
  #define INFO_TYPE_GenerAO_maximum_of_range_1         2609 /* horn hranice rozsahu 1         */
  #define INFO_TYPE_GenerAO_minimum_of_range_2         2610 /* doln hranice rozsahu 2         */
  #define INFO_TYPE_GenerAO_maximum_of_range_2         2611 /* horn hranice rozsahu 2         */
  #define INFO_TYPE_GenerAO_minimum_of_range_3         2612 /* doln hranice rozsahu 3         */
  #define INFO_TYPE_GenerAO_maximum_of_range_3         2613 /* horn hranice rozsahu 3         */
  #define INFO_TYPE_GenerAO_minimum_of_range_4         2614 /* doln hranice rozsahu 4         */
  #define INFO_TYPE_GenerAO_maximum_of_range_4         2615 /* horn hranice rozsahu 4         */
  #define INFO_TYPE_GenerAO_minimum_of_range_5         2616 /* doln hranice rozsahu 5         */
  #define INFO_TYPE_GenerAO_maximum_of_range_5         2617 /* horn hranice rozsahu 5         */

/* Ostatn*/
  #define INFO_TYPE_bus_type                          9001 /* typ sbrnice */


/*Konstanty pro funkci Td_Get_Info_DeviceName
---------------------------------------------------------------------------*/
  #define INFO_NAME_type_name                         1
  #define INFO_NAME_state                             2
  #define INFO_NAME_slot                              3
  #define INFO_NAME_serial                            4

/*------------------------------------------------------------------------------
Konstanty pro funkci Td_Set_Counter_Parameters
------------------------------------------------------------------------------*/
/* Td_Set_Counter_Parameters*/
  #define SET_CNT_CMP0_value                    1    /* hodnota 0. kompartoru*/
  #define SET_CNT_CMP1_value                    2    /* hodnota 1. kompartoru*/
  #define SET_CNT_CMP0_signal_allow             3    /* povolen nastaven signlu pro aktivaci 0. komp.*/
  #define SET_CNT_CMP1_signal_allow             4    /* povolen nastaven signlu pro aktivaci 1. komp.*/
  #define SET_CNT_CMP0_signal_clear             5    /* smazn pznaku nastavenho aktivac 0. komp.*/
  #define SET_CNT_CMP1_signal_clear             6    /* smazn pznaku nastavenho aktivac 1. komp.*/
  #define SET_CNT_CMP0_signal_route_inte_rtdo   7    /* smrovn pznaku 0. komp. na extern vstup*/
  #define SET_CNT_CMP1_signal_route_inte_rtdo   8    /* smrovn pznaku 1. komp. na extern vstup*/
  #define SET_CNT_allow_extern_reset            9    /* povolen externho resetu*/
  #define SET_CNT_range                         10   /* nastaven rozsahu tae*/
  #define SET_CNT_CWReg_config                  11   /* nastaven mdu tn tae*/
  #define SET_CNT_XSTR_allow                    12   /* povolen zachycen stavu ta ext. signlem*/
  #define SET_CNT_XSTR_clear                    13   /* smazn pznaku zachycen stavu ta ext. signlem*/
  #define SET_CNT_SlpReg_config                 14   /* nastaven aktivn hrany tae*/
  #define SET_CNT_owerflow_clear                15   /* nulovn pznaku peteen tae*/

/* funkce Td_Get_Counter_Status*/
  #define GET_CNT_CMP0_signal                   1    /* hodnota kompartoru 0*/
  #define GET_CNT_CMP1_signal                   2    /* hodnota kompartoru 1*/
  #define GET_CNT_status                        3    /* stavov informace z tae*/
  #define GET_XSTR_status                       4    /* signalizuje pchod externho signlu*/
  #define GET_CNT_TIM_value                     5    /* hodnota asovae pidruenho k tai*/
  #define GET_CNT_overflow                      6    /* bylo dosaeno peteen*/

#endif
