unit exmaple_counter_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons,tedia_DAQ01h,tedia_DAQ01_c;

const
  MAKE_LOG=false; //log a behu knihovny TEDIA_DAQ

type
  TExample = class(TForm)
    GroupBox2: TGroupBox;
    Panel4: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel10: TPanel;
    GroupBox3: TGroupBox;
    SFrequency: TEdit;
    Label1: TLabel;
    Timer_allow: TCheckBox;
    IRQ_Allow: TCheckBox;
    Label2: TLabel;
    Panel6: TPanel;
    Panel9: TPanel;
    CNT2_SetReg: TEdit;
    CNT2_GetReg: TEdit;
    CMP02_SetReg: TEdit;
    CMP12_SetReg: TEdit;
    CMP02_IRQAllow: TCheckBox;
    CMP12_IRQAllow: TCheckBox;
    Get2: TButton;
    Set2: TButton;
    Panel12: TPanel;
    CNT0_SetReg: TEdit;
    CNT0_GetReg: TEdit;
    CMP00_SetReg: TEdit;
    CMP10_SetReg: TEdit;
    CMP00_IRQAllow: TCheckBox;
    CMP10_IRQAllow: TCheckBox;
    Get0: TButton;
    Set0: TButton;
    Panel13: TPanel;
    CNT1_SetReg: TEdit;
    CNT1_GetReg: TEdit;
    CMP01_SetReg: TEdit;
    CMP11_SetReg: TEdit;
    CMP01_IRQAllow: TCheckBox;
    CMP11_IRQAllow: TCheckBox;
    Get1: TButton;
    Set1: TButton;
    GroupBox4: TGroupBox;
    SetIRQ: TButton;
    Label3: TLabel;
    CNT0_Mode: TComboBox;
    CNT1_Mode: TComboBox;
    CNT2_Mode: TComboBox;
    Panel14: TPanel;
    Memo1: TMemo;
    Label8: TLabel;
    Label9: TLabel;
    CNT0_Range: TEdit;
    CNT1_Range: TEdit;
    CNT2_Range: TEdit;
    Panel11: TPanel;
    DeleteInfoAboutIRQ: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Get0Click(Sender: TObject);
    procedure Set0Click(Sender: TObject);
    procedure Get1Click(Sender: TObject);
    procedure Set1Click(Sender: TObject);
    procedure Get2Click(Sender: TObject);
    procedure Set2Click(Sender: TObject);
    procedure SetIRQClick(Sender: TObject);
    procedure DeleteInfoAboutIRQClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    global_ability:DWord;
    irqcfgreg:DWord;
    irq_allow_cnt:array[0..2] of DWORD;

    procedure resolve_error(n_error:Dword); //Procedura, ktera vytvori message box s chybovou zpravou
    procedure collect_IRQ();
  end;

  TWait_IRQ_thread = class(TThread)
  private
    incomming_IRQ:DWord;
    base_form:^TExample;
  public
    procedure Execute; override;
    procedure save_IRQ();
  end;


var
  Example: TExample;
  Ihandle:PHandle;
  is_open:boolean;
  Pthread:TWait_IRQ_thread;
  Cnumber:DWord;

implementation

procedure TWait_IRQ_thread.save_IRQ();
var
  tmp_string:string;
  i:integer;
  selector:byte;
begin
  //pouziji promennou kam jsem si ulozil vysledek po vyvolani preruseni
  //k urceni zdroje preruseni

  tmp_string:=IntToStr(Cnumber)+'|';
  inc(Cnumber);

  if((incomming_IRQ and 16)<>0) then
    tmp_string:=tmp_string+'1|'   //Preruseni od generatoru casovych znacek probehlo
  else
    tmp_string:=tmp_string+'0|';

  if(incomming_IRQ and 32)<>0 then
  begin
    tmp_string:=tmp_string+'1|';   //Preruseni od komparatoru probehlo

    selector:=1;
    for i:=0 to 7 do                  //Zjistim detail k preruseni od komparatoru
    begin
      if((incomming_IRQ div 256) and selector)<>0 then
        tmp_string:=tmp_string+'['+IntToStr(i mod 4)+'/'+IntToStr(i div 4)+']';

      selector:=selector shl 1;       //Vyberu vzdy jeden byt a testuji srislusny kompilator jestli nevygeneroval preruseni
    end;

  end
  else
    tmp_string:=tmp_string+'0|';

  Example.Memo1.Lines.Add(tmp_string);
end;

procedure TWait_IRQ_thread.Execute();
var
  result_:DWord;
  status:DWord;
  timeout:DWord;

begin
  while (not(Terminated)) do
  begin
    result_:=Td_Wait_For_IRQ(PHandle(Ihandle),100,@status,@timeout);
    if(result_=0) then
    begin
      incomming_IRQ:=status;

      if(timeout=0) then
      begin
        if not(Terminated) then
          Synchronize(save_IRQ);
      end;
    end;
  end;
end;

{$R *.dfm}

procedure TExample.FormCreate(Sender: TObject);
var
  double_result:double;
  type_of_result:DWord;
  card_exists:boolean;
  result_:DWord;
  i:integer;
  tmp_char:PChar;
begin
  Cnumber:=0;
  is_open:=false;

  //Zpristupneni zarizeni
  result_:=Td_Init_Driver(@Ihandle,PChar('EXAM_COUNTER'));
  if result_<>0 then
  begin
    Application.MessageBox('Pravdpodobn nenalezeno dn aktivn zazen s nzvem EXAM_COUNTER, pouijte administran program [admin.exe].','Chyba!',MB_ICONERROR);
    resolve_error(result_);
    Application.Terminate;
  end;

  try

    result_:=Td_Set_Counter_Parameters(Ihandle,0,SET_CNT_XSTR_allow,1);
    if result_<>0 then
    begin
      //Nepodailo se povolit extern zachycen hodnot ta.
      resolve_error(result_);
      Exit;
    end;

    for i:=0 to 2 do
    begin
      result_:=Td_Set_Counter_Parameters(Ihandle,i,SET_CNT_range,100000);
      if result_<>0 then
      begin
        //Nepodailo se nastavit rozsah tae.
        resolve_error(result_);
        Exit;
      end;

      result_:=Td_Set_Counter_Parameters(Ihandle,i,SET_CNT_CWReg_config,9);
      if result_<>0 then
      begin
        //Nepodailo se nastavit md tae.
        resolve_error(result_);
        Exit;
      end;

      result_:=Td_Start_Counter(Ihandle,i);
      if result_<>0 then
      begin
        //Nepodailo se nastavit md tae.
        resolve_error(result_);
        Exit;
      end;

      result_:=Td_Set_Counter_Parameters(Ihandle,i,SET_CNT_ALLOW_EXTERN_RESET,1);
      if result_<>0 then
      begin
        //Nepodailo se nastavit rozsah tae.
        resolve_error(result_);
        Exit;
      end;

      result_:=Td_Set_Counter_Parameters(Ihandle,i,SET_CNT_CMP0_SIGNAL_CLEAR,1);
      if(result_<>0) then
      begin
        //Nepodailo se uloit nastaven hodnot kompartor.
        resolve_error(result_);
        exit;
      end;
    end;

    result_:=Td_Save_StartStop_Counter(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se provst start ta.
      resolve_error(result_);
      Exit;
    end;

    result_:=Td_Save_Counter_Parameters(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se upravit nastaven ta.
      resolve_error(result_);
      Exit;
    end;

    global_ability:=1;
    irqcfgreg:=96;
    irq_allow_cnt[0]:=0;
    irq_allow_cnt[1]:=0;
    irq_allow_cnt[2]:=0;
    collect_IRQ();


    GroupBox2.Enabled:=true;
    GroupBox3.Enabled:=true;
    IRQ_Allow.Checked:=true;
    Timer_allow.Checked:=false;

    Pthread:=TWait_IRQ_thread.Create(false); //Vytvoreni vlakna, ktere bude odchytavat IRQ

    is_open:=true;

  finally
    if(not(is_open)) then  //Program neproel dek "is_open:=true;" => Nastala chyba pri zjiovn parametr
    begin
      //Pravdpodobn se nejedn o zazen PCT7303A pro kter je pklad sestaven 
      result_:=Td_Close_Driver(Ihandle);
      if result_<>0 then
      begin
        //Nezdailo se zastavit men
        resolve_error(result_);
      end;
      Application.Terminate();
    end;
  end;
end;

procedure TExample.Get0Click(Sender: TObject);
var
  result_:DWord;
  value:DWord;
begin
  result_:=Td_Load_Counter(Ihandle,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Get_Counter(Ihandle,0,@value,1,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae.
    resolve_error(result_);
    exit;
  end;


  CNT0_GetReg.Text:=IntToStr(value);
end;


procedure TExample.Set0Click(Sender: TObject);
var
  result_:DWord;
  value:DWord;
  saved_value:DWord;  //Predvolba citace
  cmp0_value:DWord;   //Hodnota komparatoru 0
  cmp1_value:DWord;   //Hodnota komparatoru 0
  Ccounter:DWord;     //Cislo citace
  range_value:DWord;
begin
  
  try
    saved_value:=StrToInt(CNT0_SetReg.Text);
    cmp0_value:=StrToInt(CMP00_SetReg.Text);
    cmp1_value:=StrToInt(CMP10_SetReg.Text);
    range_value:=StrToInt(CNT0_Range.Text);
  except
    ShowMessage('V textovm poli mus bt vyplnny celoseln hodnoty');
    exit;
  end;
  Ccounter:=0;

  value:=CNT0_Mode.ItemIndex;
  if(value>2) then value:=value+1; //indexu 3 reprezentuje mod 4 ..
  value:=value shr 4;              //uprava podle interni formy CW registru
  value:=value or 1;               //polarita nulovaciho pulsu

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CWReg_config,value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_RANGE,range_value);
  if result_<>0 then
  begin
    //Nepodailo se nastavit rozsah tae.
    resolve_error(result_);
    Exit;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  value:=saved_value;
  result_:=Td_Set_Counter(Ihandle,Ccounter,@value,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_VALUE,cmp0_value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_VALUE,cmp1_value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  //Ulom aby hodnota byla zarucena pri odstarovani
  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;
  //


  irq_allow_cnt[0]:=0;

  value:=0;
  if(CMP00_IRQAllow.Checked) then
  begin
    value:=1;
    irq_allow_cnt[0]:=irq_allow_cnt[0]+1;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_SIGNAL_ALLOW,value);
  if(result_<>0) then
  begin
    //Nepodailo se povolit kompartory.
    resolve_error(result_);
    exit;
  end;

  value:=0;
  if(CMP10_IRQAllow.Checked) then
  begin
    value:=1;
    irq_allow_cnt[0]:=irq_allow_cnt[0]+16;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_SIGNAL_ALLOW,value);
  if(result_<>0) then
  begin
    //Nepodailo se povolit kompartory.
    resolve_error(result_);
    exit;
  end;

  collect_IRQ();

  //Vymazu pripadny priznak
  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_SIGNAL_CLEAR,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  //Vymazu pripadny priznak
  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_SIGNAL_CLEAR,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Start_Counter(Ihandle,Ccounter);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_StartStop_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.Get1Click(Sender: TObject);
var
  result_:DWord;
  value:DWord;
begin
  result_:=Td_Load_Counter(Ihandle,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Get_Counter(Ihandle,1,@value,1,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae.
    resolve_error(result_);
    exit;
  end;
  CNT1_GetReg.Text:=IntToStr(value);
end;

procedure TExample.Set1Click(Sender: TObject);
var
  result_:DWord;
  value:DWord;
  saved_value:DWord;  //Predvolba citace
  cmp0_value:DWord;   //Hodnota komparatoru 0
  cmp1_value:DWord;   //Hodnota komparatoru 0
  Ccounter:DWord;     //Cislo citace
  range_value:DWord;
begin

  try
    saved_value:=StrToInt(CNT1_SetReg.Text);
    cmp0_value:=StrToInt(CMP01_SetReg.Text);
    cmp1_value:=StrToInt(CMP11_SetReg.Text);
    range_value:=StrToInt(CNT1_Range.Text);
  except
    ShowMessage('V textovm poli mus bt vyplnny celoseln hodnoty');
    exit;
  end;
  Ccounter:=1;

  value:=CNT1_Mode.ItemIndex;
  if(value>2) then value:=value+1;  //Index 3 reprezentuje mod 4 ..
  value:=value shr 4;               //Uprava podle interni formy CW registru
  value:=value or 1;                //Polarita nulovaciho pulsu

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CWReg_config,value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_RANGE,range_value);
  if result_<>0 then
  begin
    //Nepodailo se nastavit rozsah tae.
    resolve_error(result_);
    Exit;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  value:=saved_value;
  result_:=Td_Set_Counter(Ihandle,Ccounter,@value,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae.
    resolve_error(result_);
    exit;
  end;


  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_VALUE,cmp0_value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_VALUE,cmp1_value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  //Ulom aby hodnota byla zarucena pri odstarovani
  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;
  //
    
  irq_allow_cnt[1]:=0;

  value:=0;

  if(CMP01_IRQAllow.Checked) then
  begin
    value:=1;
    irq_allow_cnt[1]:=irq_allow_cnt[1]+1;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_SIGNAL_ALLOW,value);
  if(result_<>0) then
  begin
    //Nepodailo se povolit kompartory.
    resolve_error(result_);
    exit;
  end;

  value:=0;
  if(CMP11_IRQAllow.Checked) then
  begin
    value:=1;
    irq_allow_cnt[1]:=irq_allow_cnt[1]+16;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_SIGNAL_ALLOW,value);
  if(result_<>0) then
  begin
    //Nepodailo se povolit kompartory.
    resolve_error(result_);
    exit;
  end;


  collect_IRQ();
  
  //Vymazu pripadny priznak
  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_SIGNAL_CLEAR,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  //Vymazu pripadny priznak
  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_SIGNAL_CLEAR,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;


  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Start_Counter(Ihandle,Ccounter);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_StartStop_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.Get2Click(Sender: TObject);
var
  result_:DWord;
  value:DWord;
begin
  result_:=Td_Load_Counter(Ihandle,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Get_Counter(Ihandle,2,@value,1,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae.
    resolve_error(result_);
    exit;
  end;

  CNT2_GetReg.Text:=IntToStr(value);
end;

procedure TExample.Set2Click(Sender: TObject);
var
  result_:DWord;
  value:DWord;
  saved_value:DWord;  //Predvolba citace
  cmp0_value:DWord;   //Hodnota komparatoru 0
  cmp1_value:DWord;   //Hodnota komparatoru 0
  Ccounter:DWord;     //Cislo citace
  range_value:DWord;
begin

  try
    saved_value:=StrToInt(CNT2_SetReg.Text);
    cmp0_value:=StrToInt(CMP02_SetReg.Text);
    cmp1_value:=StrToInt(CMP12_SetReg.Text);
    range_value:=StrToInt(CNT2_Range.Text);
  except
    ShowMessage('V textovm poli mus bt vyplnny celoseln hodnoty');
    exit;
  end;
  Ccounter:=2;

  value:=CNT2_Mode.ItemIndex;
  if(value>2) then value:=value+1;  //Index 3 reprezentuje mod 4 ..
  value:=value shr 4;               //Uprava podle interni formy CW registru
  value:=value or 1;                //Polarita nulovaciho pulsu

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CWReg_config,value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_RANGE,range_value);
  if result_<>0 then
  begin
    //Nepodailo se nastavit rozsah tae.
    resolve_error(result_);
    Exit;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  value:=saved_value;
  result_:=Td_Set_Counter(Ihandle,Ccounter,@value,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_VALUE,cmp0_value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_VALUE,cmp1_value);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  //Ulom aby hodnota byla zarucena pri odstarovani
  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;
  //

  irq_allow_cnt[2]:=0;

  value:=0;
  if(CMP02_IRQAllow.Checked) then
  begin
    value:=1;
    irq_allow_cnt[2]:=irq_allow_cnt[2]+1;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_SIGNAL_ALLOW,value);
  if(result_<>0) then
  begin
    //Nepodailo se povolit kompartory.
    resolve_error(result_);
    exit;
  end;

  value:=0;
  if(CMP12_IRQAllow.Checked) then
  begin
    value:=1;
    irq_allow_cnt[2]:=irq_allow_cnt[2]+16;
  end;

  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_SIGNAL_ALLOW,value);
  if(result_<>0) then
  begin
    //Nepodailo se povolit kompartory.
    resolve_error(result_);
    exit;
  end;

  collect_IRQ();

  //Vymazu pripadny priznak
  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP0_SIGNAL_CLEAR,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  //Vymazu pripadny priznak
  result_:=Td_Set_Counter_Parameters(Ihandle,Ccounter,SET_CNT_CMP1_SIGNAL_CLEAR,1);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Start_Counter(Ihandle,Ccounter);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;

  result_:=Td_Save_StartStop_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven hodnot kompartor.
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.SetIRQClick(Sender: TObject);
var
  result_:DWord;
  frequency:double;
  period:double;
begin
  try
    frequency:=StrToFloat(SFrequency.Text);
  except
    Showmessage('Frekvence asovae mus bt kladn slo');
    exit;
  end;

  if(3>frequency) or (1000<frequency) then
  begin
    Showmessage('Frekvence asovae mus bt v rozsahu ~3-1000');
    exit;
  end;


  global_ability:=0;
  if(IRQ_allow.Checked) then
    global_ability:=1;

  irqcfgreg:=96;

  if(Timer_allow.Checked) then
    irqcfgreg:=112;

  period:=0;

  collect_IRQ();

  result_:=Td_Config_IRQTimer(Ihandle,@frequency,@period);
  if(result_<>0) then
  begin
    //Nepodailo se nastavit frekvenci asovae.
    resolve_error(result_);
    exit;
  end;
end;


//Dv dohromady sti povolen IRQ a konfiguruje
procedure TExample.collect_IRQ();
var
  result_:DWord;
begin
  result_:=Td_Config_Ability_Generate_IRQ(Ihandle,global_ability,irqcfgreg+256*(irq_allow_cnt[0]+irq_allow_cnt[1]*2+irq_allow_cnt[2]*4));
  if(result_<>0) then
  begin
    //Nepodailo se nastavit globln mechanizmus peruen.
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.DeleteInfoAboutIRQClick(Sender: TObject);
begin
  Cnumber:=0;
  Memo1.Clear();
end;

procedure TExample.FormClose(Sender: TObject; var Action: TCloseAction);
var
  result_:DWord;
begin
  if(is_open) then
  begin
    Pthread.Terminate();
    Pthread.WaitFor();
    Pthread.FreeInstance();

    result_:=Td_Close_Driver(Ihandle);
    if result_<>0 then
    begin
      //Nezdailo se zastavit men
      resolve_error(result_);
    end;
    is_open:=false;
  end;
end;

//Procedura, ktera vytvo message box s chybovou zprvou
procedure TExample.resolve_error(n_error:DWord);
var
  function_:array[0..1000] of char;
  error_:array[0..1000] of char;
begin
  Td_Get_ErrorMessage(n_error,PChar(@function_),PChar(@error_));
  Application.MessageBox(PChar(@error_),PChar(@function_),MB_ICONERROR);
end;

end.
