unit exmaple_counter_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons,tedia_DAQ01h, tedia_DAQ01_c, Grids;

type
  TExample = class(TForm)
    GroupBox2: TGroupBox;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    GetValues: TButton;
    SetZero: TButton;
    procedure FormCreate(Sender: TObject);
    procedure GetValuesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SetZeroClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure resolve_error(n_error:Dword); //Procedura, ktera vytvori message box s chybovou zpravou
  end;
var

  Example: TExample;
  Ihandle:PHandle;
  is_open:boolean;
implementation

{$R *.dfm}

procedure TExample.FormCreate(Sender: TObject);
var
  double_result:double;
  type_of_result:DWord;
  count_registry_card_loc:DWord;
  card_exists:boolean;
  result_:DWord;
  i:integer;
begin
  result_:=Td_Init_Driver(@Ihandle,'EXAM_COUNTER');
  if result_<>0 then
  begin
    Application.MessageBox('Nenalezeno dn aktivn zazen s nzvem EXAM_COUNTER, pouijte administran program [admin.exe].','Chyba!',MB_ICONERROR);
    resolve_error(result_);
    Application.Terminate();
  end;
  is_open:=true;

  for i:=0 to 23 do
  begin
    result_:=Td_Start_Counter(Ihandle,i);
    if(result_<>0) then
    begin
      //Nezdailo se spustit tae: Td_Start_Counter.
      resolve_error(result_);
      exit;
    end;
  end;

  result_:=Td_Save_StartStop_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nezdailo se spustit tae: Td_Save_StartStop_Counter.
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.GetValuesClick(Sender: TObject);
var
  result_:DWord;
  i:integer;
  select_counter:DWord;
  value:DWord;
begin
  result_:=Td_Load_Counter(Ihandle,0);
  if(result_<>0) then
  begin
    resolve_error(result_);
    exit;
  end;

  for i:=0 to 23 do
  begin
    result_:=Td_Get_Counter(Ihandle,i,@value,1,0);
    if(result_<>0) then
    begin
      //Nezdailo se zjistit hodnotu tae.
      resolve_error(result_);
      exit;
    end;

    StringGrid1.Cells[0,i]:=IntToStr(value);
    select_counter:=select_counter shl 1; //Postupne vyberu vsech 24 citacu
  end;
  StringGrid1.Refresh();
end;

procedure TExample.FormClose(Sender: TObject; var Action: TCloseAction);
var
  result_:DWord;
begin
  if(is_open) then
  begin
    result_:=Td_Close_Driver(Ihandle);
    if result_<>0 then
    begin
      //Nezdailo se uzavt komunikaci.
      resolve_error(result_);
    end;
    is_open:=false;
  end;
end;

procedure TExample.SetZeroClick(Sender: TObject);
var
  value:DWord;
  i:integer;
  result_:DWord;
begin
  value:=0;
  for i:=0 to 23 do
  begin
    result_:=Td_Set_Counter(Ihandle,i,@value,1);
    if(result_<>0) then
    begin
      //Nezdailo se zjistit hodnotu tae.
      resolve_error(result_);
      exit;
    end;
  end;
end;

//Procedura, ktera vytvori message box s chybovou zprvou
procedure TExample.resolve_error(n_error:DWord);
var
  function_:array[0..1000] of char;
  error_:array[0..1000] of char;
begin
  Td_Get_ErrorMessage(n_error,PChar(@function_),PChar(@error_));
  Application.MessageBox(PChar(@error_),PChar(@function_),MB_ICONERROR);
end;


end.
