unit exmaple_counter_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons,tedia_DAQ01h,tedia_DAQ01_c, Grids;

const
  MAKE_LOG=false; //log a behu knihovny TEDIA_DAQ

type
  TExample = class(TForm)
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    SFrequency: TEdit;
    Label1: TLabel;
    Timer_allow: TCheckBox;
    IRQ_Allow: TCheckBox;
    GroupBox4: TGroupBox;
    SetIRQ: TButton;
    Memo1: TMemo;
    Panel11: TPanel;
    DeleteInfoAboutIRQ: TButton;
    DataGrid: TStringGrid;
    SetValues: TButton;
    GetValues: TButton;
    ClearValues: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SetIRQClick(Sender: TObject);
    procedure DeleteInfoAboutIRQClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure GetValuesClick(Sender: TObject);
    procedure DataGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ClearValuesClick(Sender: TObject);
    procedure SetValuesClick(Sender: TObject);
  private
    { Private declarations }
  public
    global_ability:DWord;
    irqcfgreg:DWord;

    procedure resolve_error(n_error:Dword); //Procedura, ktera vytvori message box s chybovou zpravou
    procedure collect_IRQ();
  end;

  TWait_IRQ_thread = class(TThread)
  private
    incomming_IRQ:DWord;
  public
    procedure Execute; override;
    procedure save_IRQ();
  end;


var

  Example: TExample;
  Ihandle:PHandle;
  is_open:boolean;
  Pthread:TWait_IRQ_thread;
  Cnumber:DWord;
implementation

procedure TWait_IRQ_thread.save_IRQ();
var
  tmp_string:string;
begin
  //Pouziji promnnou kam jsem si uloil vsledek po vyvolni peruen
  //k ureni zdroje preruen

  tmp_string:=IntToStr(Cnumber)+'|';
  inc(Cnumber);

  if((incomming_IRQ and 1)<>0) then
    tmp_string:=tmp_string+'1|'   //Preuen od genertoru asovch znaek probhlo
  else
    tmp_string:=tmp_string+'0|';

  if((incomming_IRQ and 2)<>0) then
    tmp_string:=tmp_string+'1|'   //Preuen od digitlnho portu
  else
    tmp_string:=tmp_string+'0|';


  if((incomming_IRQ and 16)<>0) then
    tmp_string:=tmp_string+'1|'   //Preuen od digitlnho portu
  else
    tmp_string:=tmp_string+'0|';

  Example.Memo1.Lines.Add(tmp_string);
end;

procedure TWait_IRQ_thread.Execute();
var
  result_:DWord;
  status:DWord;
  timeout:DWord;

begin
  while (not(Terminated)) do
  begin
    result_:=Td_Wait_For_IRQ(PHandle(Ihandle),100,@status,@timeout);
    if(result_=0) then
    begin
      incomming_IRQ:=status;

      if(timeout=0) then
      begin
        if not(Terminated) then
          Synchronize(save_IRQ);
      end;

    end
  end;
end;

{$R *.dfm}

procedure TExample.FormCreate(Sender: TObject);
var
  result_:DWord;
  val:DWord;
  i:integer;
begin
  Cnumber:=0;

  //Zpstupnn zazen
  result_:=Td_Init_Driver(@Ihandle,PChar('EXAM_COUNTER'));
  if result_<>0 then
  begin
    Application.MessageBox('Pravdpodobn nenalezeno dn aktivn zazen s nzvem EXAM_COUNTER, pouijte administran program [admin.exe].','Chyba!',MB_ICONERROR);
    resolve_error(result_);
    Application.Terminate;
  end;

  is_open:=true;

  for i:=0 to 7 do
  begin
    result_:=Td_Set_Counter_Parameters(Ihandle,i,SET_CNT_SlpReg_config,1);
    if result_<>0 then
    begin
      //Nepodailo se nastavit rozsah tae
      resolve_error(result_);
      Exit;
    end;

    val:=0;
    result_:=Td_Set_Counter(Ihandle,i,@val,1);
    if result_<>0 then
    begin
      //Nepodailo se vynulovat ta
      resolve_error(result_);
      Exit;
    end;

    result_:=Td_Save_Counter(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se vynulovat ta
      resolve_error(result_);
      Exit;
    end;

    result_:=Td_Start_Counter(Ihandle,i);
    if result_<>0 then
    begin
      //Nepodailo se nastavit md tae
      resolve_error(result_);
      Exit;
    end;
  end;

  result_:=Td_Save_StartStop_Counter(Ihandle);
  if result_<>0 then
  begin
    //Nepodailo se provst start ta
    resolve_error(result_);
    Exit;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if result_<>0 then
  begin
    //Nepodailo se upravit nastaven ta
    resolve_error(result_);
    Exit;
  end; 

  global_ability:=1;
  irqcfgreg:=3;
  collect_IRQ();

  IRQ_Allow.Checked:=true;
  Timer_allow.Checked:=false;

  //Naplnn gridu
  DataGrid.Cells[0,0]:='ta';
  for i:=0 to 7 do
  begin
    DataGrid.Cells[i+1,0]:=IntToStr(i);
    DataGrid.Cells[i+1,1]:=IntToStr(0);
    DataGrid.Cells[i+1,2]:=IntToStr(0);
  end;

  DataGrid.Cells[0,1]:='Hodnota tae';
  DataGrid.Cells[0,2]:='Hodnota asovae';
  DataGrid.ColWidths[0]:=96;
  Pthread:=TWait_IRQ_thread.Create(false); //Vytvoeni vlkna, kter bude odchytvat IRQ
end;

procedure TExample.SetIRQClick(Sender: TObject);
var
  result_:DWord;
  frequency:double;
  period:double;
begin
  try
    frequency:=StrToFloat(SFrequency.Text);
  except
    Showmessage('Frekvence asovae mus bt kladn slo');
    exit;
  end;

  if(3>frequency) or (1000<frequency) then
  begin
    Showmessage('Frekvence asovae mus bt v rozsahu ~3-1000');
    exit;
  end;


  global_ability:=0;
  if(IRQ_allow.Checked) then
    global_ability:=1;

  irqcfgreg:=3;

  if(Timer_allow.Checked) then
    irqcfgreg:=19;

  period:=0;

  collect_IRQ();

  result_:=Td_Config_IRQTimer(Ihandle,@frequency,@period);
  if(result_<>0) then
  begin
    //Nepodailo se nastavit frekvenci asovae
    resolve_error(result_);
    exit;
  end;
end;


//Dv dohromady sti povolen IRQ a konfiguruje
procedure TExample.collect_IRQ();
var
  result_:DWord;
begin
  result_:=Td_Config_Ability_Generate_IRQ(Ihandle,global_ability,irqcfgreg);
  if(result_<>0) then
  begin
    //Nepodailo se nastavit globln mechanizmus peruen
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.DeleteInfoAboutIRQClick(Sender: TObject);
begin
  Cnumber:=0;
  Memo1.Clear();
end;

procedure TExample.FormClose(Sender: TObject; var Action: TCloseAction);
var
  result_:DWord;
begin

  if(is_open) then
  begin
    Pthread.Terminate();
    Pthread.WaitFor();
    Pthread.FreeInstance();

    result_:=Td_Close_Driver(Ihandle);
    if result_<>0 then
    begin
      //Nezdailo se zastavit men
      resolve_error(result_);
    end;
    is_open:=false;
  end;
end;

//Procedura, kter vytvo message box s chybovou zprvou
procedure TExample.resolve_error(n_error:DWord);
var
  function_:array[0..1000] of char;
  error_:array[0..1000] of char;
begin
  Td_Get_ErrorMessage(n_error,PChar(@function_),PChar(@error_));
  Application.MessageBox(PChar(@error_),PChar(@function_),MB_ICONERROR);
end;

procedure TExample.GetValuesClick(Sender: TObject);
var
  result_:DWord;
  value:DWord;
  i:integer;
begin
  result_:=Td_Load_Counter(Ihandle,0);
  if(result_<>0) then
  begin
    //Nepodailo se vydat data z tae
    resolve_error(result_);
    exit;
  end;

  for i:=0 to 7 do
  begin
    result_:=Td_Get_Counter(Ihandle,i,@value,1,0);
    if(result_<>0) then
    begin
      //Nepodailo se vydat data z tae
      resolve_error(result_);
      exit;
    end;
    DataGrid.Cells[i+1,1]:=IntToStr(value);
  end;

  for i:=0 to 7 do
  begin
    result_:=Td_Get_Counter_Status(Ihandle,i,GET_CNT_TIM_value,@value);
    if(result_<>0) then
    begin
      //Nepodailo se vydat hodnoty asova
      resolve_error(result_);
      exit;
    end;
    DataGrid.Cells[i+1,2]:=IntToStr(value);
  end;

end;

procedure TExample.DataGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if(ARow<>1) then CanSelect:=false;
end;

procedure TExample.ClearValuesClick(Sender: TObject);
var
  result_:DWord;
  val:DWord;  
  i:integer;
begin
  for i:=0 to 7 do
  begin
    val:=0;
    result_:=Td_Set_Counter(Ihandle,i,@val,1);
    if result_<>0 then
    begin
      //Nepodailo se vynulovat ta
      resolve_error(result_);
      Exit;
    end;

    result_:=Td_Save_Counter(Ihandle);
    if result_<>0 then
    begin
      //Nepodailo se vynulovat ta
      resolve_error(result_);
      Exit;
    end;
  end;

  result_:=Td_Save_Counter_Parameters(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit nastaven
    resolve_error(result_);
    exit;
  end;
end;

procedure TExample.SetValuesClick(Sender: TObject);
var
  saved_value:array[0..7] of DWORD;
  result_:DWord;
  i:integer;

begin
  try
    for i:=0 to 7 do
    begin
      saved_value[i]:=StrToInt(DataGrid.Cells[i+1,1]);
    end;
  except
    Showmessage('Hodnoty ta mus bt cel kladn sla');
    exit;
  end;

  for i:=0 to 7 do
  begin
    result_:=Td_Set_Counter(Ihandle,i,@saved_value[i],1);
    if(result_<>0) then
    begin
      //Nepodailo se uloit hodnotu tae
      resolve_error(result_);
      exit;
    end;
  end;

  result_:=Td_Save_Counter(Ihandle);
  if(result_<>0) then
  begin
    //Nepodailo se uloit pedvolbu tae
    resolve_error(result_);
    exit;
  end;
end;

end.
