Option Strict Off
Option Explicit On
Module tedia_daq01_c
	'----------------------------------------------------------------------------
	'  tedia_daq01_c.bas
	'
	'    Hlavikov soubor obsahujc konstanty pro TEDIA_DAQ01.DLL (verze 2.33).
	'----------------------------------------------------------------------------
	
	
	'------------------------------------------------------------------------------
	'Konstanty pro funkci Td_Set_Parameters, Td_Get_Parameters
	'------------------------------------------------------------------------------
	Public Const SETGET_CONFIG_SAVE_delays As Short = 0 '0-neukldat, 1-ukldat zpodn do zazen automaticky pi prvnm Td_Config_Acquisition
	
	'pro nejni frekvence je zvolen mod "buffer 256B a peruen po 1 sekvenci
	Public Const SETGET_decide_frequency_0 As Short = 8 'rozhodovac hodnota frekvence pro "mod buffer 256B a peruen po 128B"
	Public Const SETGET_decide_frequency_1 As Short = 9 'rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 256B"
	Public Const SETGET_decide_frequency_2 As Short = 10 'rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 512B"
	Public Const SETGET_decide_frequency_3 As Short = 11 'rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 2kB"
	Public Const SETGET_decide_frequency_4 As Short = 12 'rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 8kB"
	Public Const SETGET_decide_frequency_5 As Short = 13 'rozhodovac hodnota frekvence pro "mod buffer 64kB a peruen po 32kB"
	Public Const SETGET_support_digital_input As Short = 14 'podpora funkce Td_Get_DI blokovm penosu dat z USB zazen
	
	Public Const SETGET_digital_0 As Short = 15 'smr digitlnho portu 0 (0-vstup, 1-vstup)
	Public Const SETGET_digital_1 As Short = 16 'smr digitlnho portu 1
	Public Const SETGET_digital_2 As Short = 17 'smr digitlnho portu 2
	Public Const SETGET_digital_3 As Short = 18 'smr digitlnho portu 3
	Public Const SETGET_INIT_SAVE_digitals As Short = 50 '0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) smry digitlnch port
	
	Public Const SETGET_delay_0 As Short = 70 'zpodn pidan pi innosti extern. multiplexeru
	Public Const SETGET_delay_1 As Short = 71 'zpodn po odmen kanlu s 1. zeslenm
	Public Const SETGET_delay_2 As Short = 72 'zpodn po odmen kanlu s 2. zeslenm
	Public Const SETGET_delay_3 As Short = 73 'zpodn po odmen kanlu s 3. zeslenm
	Public Const SETGET_delay_4 As Short = 74 'zpodn po odmen kanlu s 4. zeslenm
	Public Const SETGET_delay_5 As Short = 75 'zpodn po odmen kanlu s 5. zeslenm
	Public Const SETGET_delay_6 As Short = 76 'zpodn po odmen kanlu s 6. zeslenm
	Public Const SETGET_delay_7 As Short = 77 'zpodn po odmen kanlu s 7. zeslenm
	
	Public Const SETGET_INIT_SAVE_AO_references As Short = 100 '0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) referenn zdroje napt
	Public Const SETGET_AO_reference_0 As Short = 101 'hodnota referennho napt pro zdroj -10V
	Public Const SETGET_AO_reference_1 As Short = 102 'hodnota referennho napt pro zdroj -5V
	Public Const SETGET_AO_reference_2 As Short = 103 'hodnota referennho napt pro zdroj +5V
	Public Const SETGET_AO_reference_3 As Short = 104 'hodnota referennho napt pro zdroj +10V
	
	Public Const SETGET_INIT_SAVE_AI_calibration As Short = 110 '0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) kalibrace podle nsledujcch konstant
	Public Const SETGET_AI_offset_ADC0 As Short = 111 '8bit. hodnota kalibrujc ADC (pro gain 1x)
	Public Const SETGET_AI_range_ADC0 As Short = 112 '8bit. hodnota kalibrujc rozsah ADC
	Public Const SETGET_AI_offset_roughly As Short = 113 '8bit. hodnota kalibrujc offset vstup. zesilovace (hrube)
	Public Const SETGET_AI_offset_softly As Short = 114 '8bit. hodnota kalibrujc offset vstup. zesilovace (jemne)
	Public Const SET_AI_connect_ground As Short = 115 'pipojit vstup A/D pevodnku na GND msto multiplexoru (1-GND, 0-multiplexor)
	
	Public Const SETGET_INIT_SAVE_average As Short = 130 '0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) prmrovn vzork
	Public Const SETGET_average As Short = 131 '0-neprmrovat, 1-prmrovat
	
	Public Const SETGET_INIT_SAVE_AO As Short = 150 '0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) hodnoty, rozsahy a povolen analogovch vstup
	Public Const SETGET_AO_allow As Short = 151 '0-neaktivn, 1-analogov vstupy aktivovny
	Public Const SETGET_AO_0_value As Short = 152 'hodnota 0. analogovho vstupu
	Public Const SETGET_AO_1_value As Short = 153 'hodnota 1. analogovho vstupu
	Public Const SETGET_AO_2_value As Short = 154 'hodnota 2. analogovho vstupu
	Public Const SETGET_AO_3_value As Short = 155 'hodnota 3. analogovho vstupu
	Public Const SETGET_AO_4_value As Short = 156 'hodnota 4. analogovho vstupu
	Public Const SETGET_AO_5_value As Short = 157 'hodnota 5. analogovho vstupu
	Public Const SETGET_AO_6_value As Short = 158 'hodnota 6. analogovho vstupu
	Public Const SETGET_AO_7_value As Short = 159 'hodnota 7. analogovho vstupu
	Public Const SETGET_AO_0_range As Short = 200 'rozsah 0. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_1_range As Short = 201 'rozsah 1. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_2_range As Short = 202 'rozsah 2. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_3_range As Short = 203 'rozsah 3. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_4_range As Short = 204 'rozsah 4. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_5_range As Short = 205 'rozsah 5. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_6_range As Short = 206 'rozsah 6. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	Public Const SETGET_AO_7_range As Short = 207 'rozsah 7. analogovho vstupu (ukldan hodnota je slo identifikujc rozsah 0-3)
	
	Public Const SETGET_INIT_SAVE_AI_24or16bit As Short = 250 '-0-nenastavovat, 1-nastavovat pi inicializaci zazen (Td_Init_Driver) hodnotu poet bit pevodnku
	Public Const SETGET_AI_24bit As Short = 251 '0-16. bitov pevod, 1-24. bitov pevod
	
	Public Const SETGET_Number_Of_Strings_Info As Short = 260 '0-poet doplujcch informac uloench po dcch v SETGET_String1 - SETGET_String16 
	Public Const SETGET_String1 As Short = 261 'string 1
	Public Const SETGET_String16 As Short = 276 'string 16
	
	' Nezavysle na zarizeni (plati spolecne pro celou knihovnu, vsechna zarizeni)
	' Pokud jsou nastavovany tyto parametry lze predat do handle nil hodnotu
	Public Const SETGET_Language As Short = 350
	
	Public Const GET_Number_Of_Languages As Short = 400
	Public Const GET_LanguagesNameFirst As Short = 401
	Public Const GET_LanguagesNameMax As Short = 410
	
	'------------------------------------------------------------------------------
	'Konstanty pro funkci Td_Get_Generating_Status
	'------------------------------------------------------------------------------
	Public Const GET_BUFFER_SW_FILLED As Short = 0 'Poet naplnnch vzork v bufferu TEDIA_DAQ
	Public Const GET_BUFFER_SW_FREE As Short = 1 'Poet volnch mist pro vzorky v bufferu TEDIA_DAQ
	Public Const GET_BUFFER_HW_FILLED As Short = 2 'Poet naplnnch vzork v bufferu zazen
	
	'------------------------------------------------------------------------------
	'Konstanty pro funkci Td_Get_Info_DeviceType
	'------------------------------------------------------------------------------
	' IRQTimer
	Public Const INFO_TYPE_IRQTimer_max_frequency As Short = 1001 ' max. frekvence IRQTimeru
	Public Const INFO_TYPE_IRQTimer_min_frequency As Short = 1002 ' min. frekvence IRQTimeru
	
	' CNT
	Public Const INFO_TYPE_CNT_number_of_counters As Short = 1201 ' poet ta CNT
	Public Const INFO_TYPE_CNT_data_resolution As Short = 1202 ' poet datovch bit
	Public Const INFO_TYPE_CNT_function_resolution As Short = 1203 ' poet platnch bit
	Public Const INFO_TYPE_CNT_type As Short = 1204 ' typ ta CNT
	
	' DI
	Public Const INFO_TYPE_DI_number_of_ports As Short = 1301 ' poet DI port
	Public Const INFO_TYPE_DI_data_resolution As Short = 1302 ' poet datovch bit
	Public Const INFO_TYPE_DI_function_resolution As Short = 1303 ' poet platnch bit
	Public Const INFO_TYPE_DI_type As Short = 1304 ' typ DI port
	
	' AO
	Public Const INFO_TYPE_AO_number_of_outputs As Short = 1501 ' poet AO vstup
	Public Const INFO_TYPE_AO_data_resolution As Short = 1502 ' poet datovch bit
	Public Const INFO_TYPE_AO_function_resolution As Short = 1503 ' poet platnch bit
	Public Const INFO_TYPE_AO_type As Short = 1504 ' typ AO vstup
	Public Const INFO_TYPE_AO_number_of_ranges As Short = 1510 ' poet rozsah AO
	Public Const INFO_TYPE_AO_minimum_of_range_0 As Short = 1511 ' doln hranice rozsahu 0
	Public Const INFO_TYPE_AO_maximum_of_range_0 As Short = 1512 ' horn hranice rozsahu 0
	Public Const INFO_TYPE_AO_minimum_of_range_1 As Short = 1513 ' doln hranice rozsahu 1
	Public Const INFO_TYPE_AO_maximum_of_range_1 As Short = 1514 ' horn hranice rozsahu 1
	Public Const INFO_TYPE_AO_minimum_of_range_2 As Short = 1515 ' doln hranice rozsahu 2
	Public Const INFO_TYPE_AO_maximum_of_range_2 As Short = 1516 ' horn hranice rozsahu 2
	Public Const INFO_TYPE_AO_minimum_of_range_3 As Short = 1517 ' doln hranice rozsahu 3
	Public Const INFO_TYPE_AO_maximum_of_range_3 As Short = 1518 ' horn hranice rozsahu 3
	
	' DO
	Public Const INFO_TYPE_DO_number_of_ports As Short = 1701 ' poet DO port
	Public Const INFO_TYPE_DO_data_resolution As Short = 1702 ' poet datovch bit
	Public Const INFO_TYPE_DO_function_resolution As Short = 1703 ' poet platnch bit
	Public Const INFO_TYPE_DO_type As Short = 1704 ' typ DO port
	
	' ScanBuffer
	Public Const INFO_TYPE_ScanBuffer_max_frequency As Short = 2001 ' max. frekvence pro ScanBuffer
	Public Const INFO_TYPE_ScanBuffer_min_frequency As Short = 2002 ' min. frekvence pro ScanBuffer
	Public Const INFO_TYPE_ScanBuffer_max_number_of_channel As Short = 2010 ' max. poet kanl sekvence
	
	' ScanAI
	Public Const INFO_TYPE_ScanAI_number_of_inputs As Short = 2101 ' poet ScanAI vstup
	Public Const INFO_TYPE_ScanAI_data_resolution As Short = 2102 ' poet datovch bit
	Public Const INFO_TYPE_ScanAI_function_resolution As Short = 2103 ' poet platnch bit
	Public Const INFO_TYPE_ScanAI_type As Short = 2104 ' typ ScanAI vstup
	Public Const INFO_TYPE_ScanAI_number_of_ranges As Short = 2110 ' poet rozsah ScanAI
	Public Const INFO_TYPE_ScanAI_minimum_of_range_0 As Short = 2111 ' doln hranice rozsahu 0
	Public Const INFO_TYPE_ScanAI_maximum_of_range_0 As Short = 2112 ' horn hranice rozsahu 0
	Public Const INFO_TYPE_ScanAI_minimum_of_range_1 As Short = 2113 ' doln hranice rozsahu 1
	Public Const INFO_TYPE_ScanAI_maximum_of_range_1 As Short = 2114 ' horn hranice rozsahu 1
	Public Const INFO_TYPE_ScanAI_minimum_of_range_2 As Short = 2115 ' doln hranice rozsahu 2
	Public Const INFO_TYPE_ScanAI_maximum_of_range_2 As Short = 2116 ' horn hranice rozsahu 2
	Public Const INFO_TYPE_ScanAI_minimum_of_range_3 As Short = 2117 ' doln hranice rozsahu 3
	Public Const INFO_TYPE_ScanAI_maximum_of_range_3 As Short = 2118 ' horn hranice rozsahu 3
	Public Const INFO_TYPE_ScanAI_minimum_of_range_4 As Short = 2119 ' doln hranice rozsahu 4
	Public Const INFO_TYPE_ScanAI_maximum_of_range_4 As Short = 2120 ' horn hranice rozsahu 4
	Public Const INFO_TYPE_ScanAI_minimum_of_range_5 As Short = 2121 ' doln hranice rozsahu 5
	Public Const INFO_TYPE_ScanAI_maximum_of_range_5 As Short = 2122 ' horn hranice rozsahu 5
	Public Const INFO_TYPE_ScanAI_minimum_of_range_6 As Short = 2123 ' doln hranice rozsahu 6
	Public Const INFO_TYPE_ScanAI_maximum_of_range_6 As Short = 2124 ' horn hranice rozsahu 6
	
	' ScanCNT
	Public Const INFO_TYPE_ScanCNT_number_of_counters As Short = 2201 ' poet ta ScanCNT
	Public Const INFO_TYPE_ScanCNT_data_resolution As Short = 2202 ' poet datovch bit
	Public Const INFO_TYPE_ScanCNT_function_resolution As Short = 2203 ' poet platnch bit
	Public Const INFO_TYPE_ScanCNT_type As Short = 2204 ' typ ta ScanCNT
	
	' ScanDI
	Public Const INFO_TYPE_ScanDI_number_of_ports As Short = 2301 ' poet ScanDI port
	Public Const INFO_TYPE_ScanDI_data_resolution As Short = 2302 ' poet datovch bit
	Public Const INFO_TYPE_ScanDI_function_resolution As Short = 2303 ' poet platnch bit
	Public Const INFO_TYPE_ScanDI_type As Short = 2304 ' typ ScanDI port
	
	' GenerBuffer
	Public Const INFO_TYPE_GenerBuffer_max_frequency As Short = 2501 ' max. frekvence v reimu stream
	Public Const INFO_TYPE_GenerBuffer_min_frequency As Short = 2502 ' min. frekvence v reimu stream
	Public Const INFO_TYPE_GenerBuffer_max_DAC_frequency As Short = 2503 ' max. frekvence v cyklickm reimu
	Public Const INFO_TYPE_GenerBuffer_min_DAC_frequency As Short = 2504 ' min. frekvence v cyklickm reimu
	Public Const INFO_TYPE_GenerBuffer_DAC_depth As Short = 2505 ' velikost bufferu pro generovani
	Public Const INFO_TYPE_GenerBuffer_cycling_mode As Short = 2506 ' umouje zazen cyklick generovani bufferu?
	Public Const INFO_TYPE_GenerBuffer_max_number_of_channel As Short = 2510 ' max. poet kanl sekvence
	
	' GenerAO
	Public Const INFO_TYPE_GenerAO_number_of_outputs As Short = 2601 ' poet GenerAO vstup
	Public Const INFO_TYPE_GenerAO_data_resolution As Short = 2602 ' poet datovch bit
	Public Const INFO_TYPE_GenerAO_function_resolution As Short = 2603 ' poet platnch bit
	Public Const INFO_TYPE_GenerAO_type As Short = 2604 ' typ GenerAO vstup
	Public Const INFO_TYPE_GenerAO_number_of_ranges As Short = 2605 ' poet rozsah GenerAO
	Public Const INFO_TYPE_GenerAO_minimum_of_range_0 As Short = 2606 ' doln hranice rozsahu 0
	Public Const INFO_TYPE_GenerAO_maximum_of_range_0 As Short = 2607 ' horn hranice rozsahu 0
	Public Const INFO_TYPE_GenerAO_minimum_of_range_1 As Short = 2608 ' doln hranice rozsahu 1
	Public Const INFO_TYPE_GenerAO_maximum_of_range_1 As Short = 2609 ' horn hranice rozsahu 1
	Public Const INFO_TYPE_GenerAO_minimum_of_range_2 As Short = 2610 ' doln hranice rozsahu 2
	Public Const INFO_TYPE_GenerAO_maximum_of_range_2 As Short = 2611 ' horn hranice rozsahu 2
	Public Const INFO_TYPE_GenerAO_minimum_of_range_3 As Short = 2612 ' doln hranice rozsahu 3
	Public Const INFO_TYPE_GenerAO_maximum_of_range_3 As Short = 2613 ' horn hranice rozsahu 3
	Public Const INFO_TYPE_GenerAO_minimum_of_range_4 As Short = 2614 ' doln hranice rozsahu 4
	Public Const INFO_TYPE_GenerAO_maximum_of_range_4 As Short = 2615 ' horn hranice rozsahu 4
	Public Const INFO_TYPE_GenerAO_minimum_of_range_5 As Short = 2616 ' doln hranice rozsahu 5
	Public Const INFO_TYPE_GenerAO_maximum_of_range_5 As Short = 2617 ' horn hranice rozsahu 5
	
	' Ostatn
	Public Const INFO_TYPE_bus_type As Short = 9001 ' typ sbrnice
	
	'------------------------------------------------------------------------------
	'Konstanty pro funkci Td_Get_Info_DeviceName
	'------------------------------------------------------------------------------
	Public Const INFO_NAME_type_name As Short = 1
	Public Const INFO_NAME_state As Short = 2
	Public Const INFO_NAME_slot As Short = 3
	Public Const INFO_NAME_serial As Short = 4
	
	'------------------------------------------------------------------------------
	'Konstanty pro funkci Td_Set_Counter_Parameters
	'------------------------------------------------------------------------------
	' Zazen PCT-7303A - funkce Td_Set_Counter_Parameters
	Public Const SET_CNT_CMP0_value As Short = 1 ' hodnota 0. kompartoru
	Public Const SET_CNT_CMP1_value As Short = 2 ' hodnota 1. kompartoru
	Public Const SET_CNT_CMP0_signal_allow As Short = 3 ' povolen nastaven signlu pro aktivaci 0. komp.
	Public Const SET_CNT_CMP1_signal_allow As Short = 4 ' povolen nastaven signlu pro aktivaci 1. komp.
	Public Const SET_CNT_CMP0_signal_clear As Short = 5 ' smazn pznaku nastavenho aktivac 0. komp.
	Public Const SET_CNT_CMP1_signal_clear As Short = 6 ' smazn pznaku nastavenho aktivac 1. komp.
	Public Const SET_CNT_CMP0_signal_route_inte_rtdo As Short = 7 ' smrovn pznaku 0. komp. na extern vstup
	Public Const SET_CNT_CMP1_signal_route_inte_rtdo As Short = 8 ' smrovn pznaku 1. komp. na extern vstup
	Public Const SET_CNT_allow_extern_reset As Short = 9 ' povolen externho resetu
	Public Const SET_CNT_range As Short = 10 ' nastaven rozsahu tae
	Public Const SET_CNT_CWReg As Short = 11 ' nastaven mdu tn tae
	Public Const SET_CNT_XSTREn As Short = 12 ' povolen zachycen stavu ta ext. signlem
	Public Const SET_CNT_XSTR_clear As Short = 13 ' smazn pznaku zachycen stavu ta ext. signlem
	Public Const SET_CNT_SlpReg_config As Short = 14 ' nastaven aktivn hrany tae
	Public Const SET_CNT_owerflow_clear As Short = 15 ' nulovn pznaku peteen tae
	
	' Zazen PCT-7303A - funkce Td_Get_Counter_Status
	Public Const GET_CNT_CMP0_signal As Short = 1 ' hodnota kompartoru 0
	Public Const GET_CNT_CMP1_signal As Short = 2 ' hodnota kompartoru 1
	Public Const GET_CNT_status As Short = 3 ' stavov informace z tae
	Public Const GET_XSTR_status As Short = 4 ' signalizuje pchod externho signlu
	Public Const GET_CNT_TIM_value As Short = 5 ' hodnota asovae pidruenho k tai
	Public Const GET_CNT_overflow As Short = 6 ' bylo dosaeno peteen
End Module